<template>
  <section id="heroes">
    <h2 class="text-center">My Heroes</h2>
    <div class="row mt-4 mb-4">
      <div class="input-group col-md-5">
        <div class="input-group-prepend">
          <span class="input-group-text" id="inputGroup-sizing-default">Hero name</span>
        </div>
        <input type="text" class="form-control" aria-label="Default" v-model="heroName"
               aria-describedby="inputGroup-default" @keyup.enter="addHero">
        <button class="btn btn-outline-success ml-3" @click="addHero">Add</button>
      </div>
    </div>
    <div class="heroes-box row">
      <div class="heroes-list col-12" v-for="hero of heroList" :key="hero.id">
        <n-link class="heroes-link" :to='`/detail/${ hero.id }`'>
          <div class="badge">{{ hero.id }}</div>
          <div class="detail">{{ hero.name }}</div>
        </n-link>
        <button class="delete" title="delete hero" @click='deleteHero(hero.id)'>x</button>
      </div>
    </div>
  </section>
</template>

<script>
  import { mapActions } from 'vuex'
  export default {
    name: "heroes",
    data () {
      return {
        heroName: '',
        heroList: this.$store.getters['heroes/getHeroes']
      }
    },
    methods: {
      ...mapActions({
        addMessages: 'setMessages',
        addHeroes: 'setHeroes',
        clearHeroesById: 'setHeroes'
      }),
      addHero () {
        const vm = this
        const findLengthId = vm.heroList.length > 0 ? vm.heroList[vm.heroList.length-1].id + 1 : 11
        const heroesObj = {
          id: findLengthId,
          type: 'add',
          name: vm.heroName
        }
        if (vm.heroName) {
          vm.addMessages(`added hero w/ id=${findLengthId}`)
          vm.addHeroes(heroesObj)
        }
        vm.heroName = ''
      },
      deleteHero (id) {
        const vm = this
        const clearHeroesObj = {
          id: id,
          type: 'delete'
        }
        vm.addMessages(`deleted hero id=${id}`)
        vm.clearHeroesById(clearHeroesObj)
      }
    }
  }
</script>

<style lang="scss" scoped>
  #heroes {
    .heroes-box {
      margin: 0 0 2em 0;
      list-style-type: none;
      padding: 0;
      width: 20em;
      .heroes-list {
        position: relative;
        cursor: pointer;
        background-color: #EEE;
        margin: .5em;
        padding: 0;
        display: flex;
        border-radius: 4px;
        &:hover {
          color: #607D8B;
          background-color: #DDD;
          left: .1em;
        }
      }
      .heroes-link {
        color: #333;
        text-decoration: none;
        position: relative;
        display: flex;
        width: 100%;
        &:hover {
          color:#607D8B;
        }
        .detail {
          width: 100%;
          display: flex;
          align-items: center;
          padding: 5px 10px;
        }
        .badge {
          font-size: small;
          color: white;
          background-color: #405061;
          position: relative;
          height: 100%;
          padding: 5px 10px;
          display: flex;
          align-items: center;
          border-radius: 4px 0 0 4px;
        }
      }
    }
    .delete {
      background-color: gray;
      color: white;
      border: none;
      padding: 5px 10px;
      margin: 5px 5px 5px 0;
      border-radius: 4px;
      cursor: pointer;
      font-family: Arial;
      &:hover {
        background-color: #a8a8a8;
      }
    }
  }
</style>
